package ir.javacup.report;

import java.util.Arrays;
import java.util.List;

public class ReportService {

	public ReportService(InformationRepository repository) {
	
	}
	
	public List<CityInformation> sumByCity(int year) {
		
	}

	public List<CityMonthInformation> averageByCityAndMonth(int year) {
		
	}
	
	public static void main(String[] args) {
		ReportService service = new ReportService(new InformationRepository() {
			@Override
			public List<Information> fetchAll() {
				return Arrays.asList(
					new Information("Kerman", "1395/03/11", 62L), new Information("Tehran", "1395/09/12", 90L),
					new Information("Tehran", "1396/11/30", 31L), new Information("Semnan", "1396/01/13", 93L)
				);
			}
		});
		
		List<CityInformation> sumResults = service.sumByCity(1396);
		System.out.printf("sum total: %d%n", sumResults.size());
		CityInformation sumFirst = sumResults.get(0);
		System.out.printf("1: %s %d%n", sumFirst.getCity(), sumFirst.getSum());
		CityInformation sumSecond = sumResults.get(1);
		System.out.printf("2: %s %d%n", sumSecond.getCity(), sumSecond.getSum());
		
		List<CityMonthInformation> avgResults = service.averageByCityAndMonth(1395);
		System.out.printf("avg total: %d%n", avgResults.size());
		CityMonthInformation avgFirst = avgResults.get(0);
		System.out.printf("1: %s %d %f%n", avgFirst.getCity(), avgFirst.getMonth(), avgFirst.getAverage());
		CityMonthInformation avgSecond = avgResults.get(1);
		System.out.printf("2: %s %d %f%n", avgSecond.getCity(), avgSecond.getMonth(), avgSecond.getAverage());
	}

}
